clear 
%%%%%%%%%%%%%%%%Options%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
baseline=0 %does not modify raw data
mywname='cdf97' %wavelet family
wlevel=4 %decomposition level
store=0 %Change to 1 to add Huffman entropy coding
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
icase=input('Please enter approximation method (a or b) \n','s');
if icase=='a'
PRD0=input('Please enter PRD0 (e.g. 0.4217 to reproduce Table 2)  \n');
end
del=input('Please enter quantization parameter (e.g. 32 to reproduce Table 2 with method a) and 39 for b) \n');
dataN={'100','101','102','103','104','105','106', '107','108','109','111', '112', '113', '114', '115',...
'116','117','118','119','121','122','123','124','200','201','202','203','205', '207','208', '209',...
'210','212','213','214','215','217','219','220','221','222','223','228','230',...
'231', '232','233','234'};
tic
bw=2000;
WPath='ECG_Compression/Compressed_Records/Comp_Record_';
kd=0; for dat=dataN kd=kd+1;
filenamer=['ECG_Compression/MIT_BIHA_DATA/Record_' char(strcat(dat, '_11bits.dat'))];
filenamew=[WPath char(strcat(dat, '_HDF5.mat'))];
fid=fopen(filenamer,'r');
f=fread(fid,'ubit11');
fclose(fid);
f=f-baseline;
%Apply DWT
[fw,wl]=mydwt(f,wlevel,mywname);
L=numel(fw);
switch  icase
case 'a'
tol=PRD0*norm(f)/100;
[cs,wind]=SLWC(fw,tol);
case 'b'
cs=fw;
wind=1:L;
wind=wind';
otherwise 
fprintf('Unknown case \n');break
end
%Quantization of wavelet coefficients
csq=sign(cs).*floor(abs(cs)/del+0.5);
I0=find(csq==0);
if isempty(I0)==0 %remove the zeros
csq(I0)=[];
wind(I0)=[];
end
%Organization and Storage
clear vc vi vs
[or,ior]=sort(wind); %sort the indices
vc=abs(csq(ior));
%take differences
vi=[or(1) diff(or)']; %(note: invert with cumsum([vi]);
vs=(sign(csq(ior))+ 1)./2;%encode the signs as zeros and ones
if store==0
save(filenamew, 'L', 'del', 'vi',  'vc', 'vs'); %HDF5 file
else
xS{1}=vs;
xCC{1}=vc;
xC{1}=vi;
ys=Huff06(xS);
yi=Huff06(xC);
yc=Huff06(xCC);
save(filenamew, 'L', 'del', 'yi',  'yc', 'ys');
end
hf11=dir(filenamer);
hfH=dir(filenamew);
CR(kd)=hf11.bytes/hfH.bytes; %calculate CR 
end
toc
average_compression_time_per_record=toc/kd
fprintf('\n')
fprintf('-------------------------------------\n')
sprintf('average_CR= %1.2f, std_CR= %1.2f', mean(CR), std(CR))
fprintf('-------------------------------------\n')
