%
clear 
%%%%%%%%%%%%%%%%Options%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
baseline=0 %does not modify raw data
mywname='cdf97' %wavelet family
wlevel=4 %decomposition level
store=0 %Change to 1 to add Huffman entropy coding
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dat=input('Please enter record number (from the MIT_BIHA_database) \n ','s');
icase=input('Please enter approximation method (a or b) \n','s');
if icase=='a'
PRD0=input('Please enter PRD0 (e.g. 0.4217)  \n');
end
del=input('Please enter quantization parameter (e.g. 32 for a) and 39 for b) \n');
%
filenamer=['ECG_Compression/MIT_BIHA_DATA/Record_' char(strcat(dat, '_11bits.dat'))];
filenamew_tmp='ECG_Compression/Comp_Record.mat'
fid=fopen(filenamer,'r');
f=fread(fid,'ubit11');
fclose(fid);
f=f-baseline;
tic
base=0;
[fw,wl]=mydwt(f,wlevel,mywname);
L=numel(fw);
if icase=='a'
tol=PRD0*norm(f)/100;
[cs,wind]=SLWC(fw,tol);
end
if icase=='b'
cs=fw;
wind=1:numel(fw);
wind=wind';
end
%quantization of wavelet coefficients
csq=sign(cs).*floor(abs(cs)/del+0.5);
I0=find(csq==0);
if isempty(I0)==0 %remove the zeros
csq(I0)=[];
wind(I0)=[];
end
%Organization and Storage
clear vc vi vs
[or,ior]=sort(wind); %sort the indices
vc=abs(csq(ior)); 
%take differences
vi=[or(1) diff(or)'];
%invert with cumsum([vi]);
%vi=vdif(or); %take differences
vs=(sign(csq(ior))+ 1)./2; %encode the signs as zeros and ones
%
if store==0;
save (filenamew_tmp, 'del','L', 'vi', 'vc', 'vs'); %save in HDF5 format
else
xS{1}=vs;
xC{1}=vi;
xCC{1}=vc;
ys=Huff06(xS);
yc=Huff06(xCC);
yi=Huff06(xC);
save (filenamew_tmp, 'del','L','yi','yc','ys'); %save in HDF5 format
end
hf11=dir(filenamer);
hfH=dir(filenamew_tmp);
CR=hf11.bytes/hfH.bytes %calculate CR%
toc
